package site.hanschen.bytecode.java;

/**
 * Class access and property modifiers
 *
 * @author chenhang
 */
public enum ClassAccess {

    ACC_PUBLIC(0x0001),
    ACC_FINAL(0x0010),
    ACC_SUPER(0x0020),
    ACC_INTERFACE(0x0200),
    ACC_ABSTRACT(0x0400),
    ACC_SYNTHETIC(0x1000),
    ACC_ANNOTATION(0x2000),
    ACC_ENUM(0x4000);

    private int flag;

    ClassAccess(int flag) {
        this.flag = flag;
    }

    public int getFlag() {
        return flag;
    }

    public boolean is(int mask) {
        return (flag & mask) != 0;
    }
}
